From f3e65326fad9c8f4f83fae333045fb90d80c7831 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Louis-Philippe=20V=C3=A9ronneau?= <pollo@debian.org>
Date: Sun, 21 Nov 2021 23:04:45 -0500
Subject: [PATCH] Filter requires-extra when parsing for dependencies in
 .dist-info files.

Closes: #99837
---
 dhpython/depends.py        | 3 ++-
 tests/tpb02/pyproject.toml | 5 +++++
 2 files changed, 7 insertions(+), 1 deletion(-)

diff --git a/dhpython/depends.py b/dhpython/depends.py
index d00334b..f6983af 100644
--- a/dhpython/depends.py
+++ b/dhpython/depends.py
@@ -255,7 +255,8 @@ class Dependencies:
                     metadata = email.message_from_string(fp.read())
                 requires = metadata.get_all('Requires-Dist', [])
                 for req in requires:
-                    self.depend(guess_deps(req=req))
+                    if ";" not in req:  # filter for things like 'tox ; extra == "test"'
+                        self.depend(guess_deps(req=req))
 
         # add dependencies from --depends
         for item in options.depends or []:
diff --git a/tests/tpb02/pyproject.toml b/tests/tpb02/pyproject.toml
index 94ea7d0..ad9fc43 100644
--- a/tests/tpb02/pyproject.toml
+++ b/tests/tpb02/pyproject.toml
@@ -6,3 +6,8 @@ build-backend = "flit_core.buildapi"
 module = "foo"
 author = "Stefano Rivera"
 requires = ["toml"]
+
+[tool.flit.metadata.requires-extra]
+test = [
+    "tox"
+]
-- 
2.34.0

